#include "msgcls.h"

typedef unsigned char bool;
#ifndef CONFERENCES
#define CONFERENCES

struct CNAMES {
        char name[14];          // conference name
        bool publicconf;        // new user default registration
        bool autorejoin;        // auto-rejoin for this conference
        bool viewmembers;       // allow viewing conference members
        bool privuplds;         // make all uploads private
        bool privmsgs;          // make all messages private
        bool echomail;          // is this an echo-mail conference
        int reqseclevel;        // security required to join non-public conf
        int addsec;             // additional security level added after join
        int addtime;            // additional time added after join
        char msgblocks;         // number of message base index blocks
        char msgfile[32];       // name and location of messages file
        char usermenu[32];      // name and location of users menu
        char sysopmenu[32];     // name and location of sysops menu
        char newsfile[32];      // name and location of conference news
        char pubupldsort;       // sort type for public upload dir file
        char uplddir[29];       // name and location of public upload dir file
        char pubuplodloc[26];   // public upload location
        char prvupldsort;       // sort type for public upload dir file
        char privdir[29];       // name and location of private upload dir file
        char prvupldloc[26];    // private upload location
        char drsmenu[29];       // name and location of conference doors menu
        char drsfile[33];       // name and location of DOORS.LST file
        char bltmenu[29];       // name and location of conference blt menu
        char bltnameloc[33];    // name and location of BLT.LST file
        char scrmenu[29];       // name and location of conference scripts menu
        char scrnameloc[33];    // name and location of SCRIPT.LST
        char dirmenu[29];       // name and location of directories menu
        char dirnameloc[33];    // name and location of DIR.LST file
        char pthnameloc[33];    // name and location of DLPATH.LST file
};

class CONFDATA{
        struct  CNAMES cnames;
        char    filename[34];
        int     fhandle;
        int     recsize;
public:
        CONFDATA(char*);
        ~CONFDATA(void);
        void    get_conf_data(ulong);
        char    *get_conf_name();
        char    *get_msg_file();
		char	*get_uplddir();
		char	*get_pubuplodloc();
};
#endif
