#include <sys\stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include <process.h>
#include <fcntl.h>
#include <iostream.h>
#include <io.h>

#include "msgcls.h"
#include "bsreal.h"
#include "cnmcls.h"
#include "tools.h"


// THIS INFO STORED IN TOOLS.CPP
//
extern char cn[80];    // CNAMES.@@@ LOCATION
extern int NWF;        // Multi-node flag (default is single node);

// USER RECORD, MEMORY IS ALLOCATED FOR 'numitems'
//
struct record{
        char name[26];
        int print_private;
        int form_feeds;   // Not active yet
        int option_active;
        char msgconf[6];
        char range1[6];
        char range2[6];
}*data;

int numitems;                   // Number of items (or records).
int port=0;                     // printer port (not currently configurable).
ulong *msgalrt_ndx;             // This will contain the MSGALRT.NDX file.
int     msgalrt_handle;         // File handle for index.
ulong msgalrt_size;

// THE FOLLOWING GLOBAL VARIABLES WILL BE CHANGINE CONTINUOUSLY (BASED ON
// CURRENT USER RECORD).
//
ulong CONFSAVE;                 // Conference to save messages to.
ulong RANGE1;                   // Starting conference
ulong RANGE2;                   // Ending conference


// BIT MANIPULATION DECLARATIONS FOR CONFERENCE ACTIVE STATUS
//
div_t x;                // Used to find location in bitmap
int conf_status;        // Conference Active status 1 or 0.  Set by GET_CONF
char conf_bitmap[875];  // This bitmap will cover 7000 conferences

#define CONF_ON(conf){ x=div(conf,8);set_bit_byte(conf_bitmap,x.quot,x.rem,1);}
#define GET_CONF(conf){ x=div(conf,8); conf_status=get_bit_byte(conf_bitmap,x.quot,x.rem);}


// CHECK TO SEE IF NAME IS TO BE PROCESSED
//
int Name_check(char *Name){
        char *trimName;
        trimName=trim(Name);                    // Spaces trimmed for comparison (below)
        int len=strlen(trimName);               // We'll use this for strncmp (below)
        for(int i=0;i<numitems;i++){
                if ((strncmp(trimName,trim(data[i].name),len))==0){

                        // These will be set to the applicable data for specified
                        // individual upon return.  Let's let the parent process worry
                        // about what to do with them.
                        //
                        CONFSAVE=(ulong)atol((const char*)data[i].msgconf);
                        RANGE1=(ulong)atol((const char*)data[i].range1);
                        RANGE2=(ulong)atol((const char*)data[i].range2);

                        // Return code based on configuration of user record
                        //
                        if (data[i].option_active==2) return 4;
                        if (data[i].option_active==NO) return 0;
                        if ((data[i].form_feeds==YES)&&(data[i].print_private==YES)) return 4;
                        if (data[i].print_private==YES) return 3;
                        if (data[i].form_feeds==YES) return 2;
                        if (data[i].option_active==YES) return 1;
                }
        }
        return(0);
}


// PRINT MESSAGE HEADING
//
int print_data(msg_index& Data, IMBH& message, char *conference){
                char buffer[25];

                // NOTE: Although we don't have 'port' configurable, I did not
                // hardcode port (here) so that when it is configurable no other
                // code will need to be changed.
                //
                if((prtck(port))==-1) return -1;
                prtstr(port,CR CR"Date: ");
                prtstr(port,message.get_entry_date());
                prtstr(port," (");
                prtstr(port,message.get_entry_time());
                prtstr(port,")");
                prtstr(port,"            Number: ");
                prtstr(port,ltoa(message.get_msg_nmbr(),buffer,10));
                prtstr(port," of ");
                prtstr(port,ltoa(Data.get_high_msg(),buffer,10));
                prtstr(port,CR"From: ");
                prtstr(port,message.get_msg_from());
                prtstr(port,"   Refer#: ");
                prtstr(port,message.message_refer());
                char status=message.get_msg_status();
                prtstr(port,CR"  To: ");
                prtstr(port,message.get_msg_to());
                prtstr(port,"     Read: ");
                prtstr(port,message.message_read());
                prtstr(port,CR"Subj: ");
                prtstr(port,message.get_msg_subject());
                prtstr(port,"   Status: ");
                prtstr(port,message.status_type());
                prtstr(port,CR"Conf: ");
                prtstr(port,conference);
                return 0;
}

// RETRIEVES MESSAGE DATA AND PROCESSES IT
//
void show_msg_stat(msg_index& Data,ulong msg,char *conf,ulong confnmbr){
        char ch,status;
        char conference[25];
        int i,config;

        int handle=Data.get_msg_fhandle();      // Get the filehandle. We will need
                                                // it to read in the message data.
                                                // (below).

        ulong msgoffset=Data.get_msgidx_offset(msg);// Get the messages offset in the
                                                    // message database for 'msg' number.

        if (msgoffset>2){          // Won't be a message to access if 0.
                IMBH message(handle,msgoffset); // Class that will read in the message

                // send to printer if Name is in list
                //
                if((config=Name_check(message.get_msg_to()))>0){
                        status=message.get_msg_status(); // status of message is used below
                        sprintf(conference,"%s (%u)",conf,confnmbr); // used for print_data();

                        if((confnmbr>=RANGE1) && (confnmbr<=RANGE2)){
                                if(config==4){  // Copy message (no print)
                                        if(CONFSAVE!=confnmbr)
                                        append_message(message,CONFSAVE);
                                } else {
                                        if((print_data(Data,message,conference))==-1)
                                        return; // Return if printer error occurred
                                        if( (config>2) || (status=='-') || (status==' ') ) {
                                                char *msgtext=message.get_msg_text();
                                                prtstr(port,CR CR);
                                                prtstr(port,msgtext);
                                                prtstr(port,CR"<<<>>>");
                                         } else prtstr(port,CR"<<<>>>");
                                }
                        }
                }
        }
}


// READ IN NAMES TO DYNAMICALLY ALLOCATED ARRAY (PUBLIC STRUCTURE RECORD)
//
void read_names(){
        FILE *fp;
        char buffer[80],*ptr;
        if((fp=fopen("MSGALRT.USR","rt"))==NULL){
                cout << CR"Error encountered trying to read MSGALRT.USR file";
                exit(1);
        }
        fgets(buffer,80,fp);
        if((ptr=strstr(buffer,"\n"))!=NULL) *ptr='\0';

        numitems=atoi(buffer); // Number of items in array will line 1 of file.

        // LET'S ALLOCATE MEMORY FOR ARRAY
        //
        data=(struct record*)calloc(numitems,sizeof(struct record));
        if (data==NULL){
                fputs("ERROR! insufficient RAM",stderr);
                exit(1);}

        // NOW LET'S INITIALIZE THE ARRAY
        //
        int status;
        int cntr=0;
        while((fgets(buffer,80,fp))!=NULL){
                if((ptr=strstr(buffer,"\n"))!=NULL) *ptr=' ';
                //       RECORD DATA              COL in MSGALRT.USR
                //       ------------------------ --------------------
                memmove( data[cntr].name                         ,&buffer[5],25);
                         data[cntr].print_private =(int)buffer[0]-'0';
                         data[cntr].option_active =(int)buffer[2]-'0';
                memmove( data[cntr].msgconf              ,&buffer[35],5);
                memmove( data[cntr].range1               ,&buffer[40],5);
                memmove( data[cntr].range2               ,&buffer[45],5);

                RANGE1=(ulong)atol((const char*)data[cntr].range1);
                RANGE2=(ulong)atol((const char*)data[cntr].range2);
                for(int i=RANGE1;i<=RANGE2;i++)  // Set conference bit map with
                        CONF_ON(i);              // active conferences
                cntr++;
                if(cntr>numitems-1) break;
        }
        fclose(fp);
}


// THIS IS SHOWN FOR MSG ?
//
void show_instructions(){
        char *str=CR"  Usage: MSGS (documentation feature not completed)";
        cout << str;
        exit(1);
}


// MAIN LOOP ROUTINE
//
void process_data(ulong confnmbr){
        ulong msgnmbr;
        ulong *msgnumptr;


        // Our MSGALRT.NDX file (message pointers) is in RAM. "msgalrt_ndx"
        // points to it.  There is one message pointer per conference in this file.
        //
        msgnumptr=msgalrt_ndx;          // msgnum will be our pointer to msgalrt_ndx

        CONFDATA confdata(cn);                // Open CNAMES.@@@
        confdata.get_conf_data(confnmbr);     // Read in conference #'confnmbr' data
        char *conf=confdata.get_conf_name();  // Get conference Name
        char *msgs=confdata.get_msg_file();   // Get MSGS location
        msg_index Data(msgs,NWF);             // Open Message Base and Index

        msgnumptr+=confnmbr;                  // msg pointer + conference offset
        msgnmbr=*msgnumptr;

        *msgnumptr=(ulong)Data.get_high_msg()+1;

        if(msgnmbr==0) msgnmbr=*msgnumptr;

        for(ulong i=msgnmbr; i< (ulong)*msgnumptr ;i++) // From msg to high msg
                show_msg_stat(Data,i,conf,confnmbr);
}


// SET UP MESSAGE POINTERS FOR ALL CONFERENCES
//
ulong set_msg_pointers(){
        ulong total_conf=atol(get_pcboard_dat(108))+1;

        msgalrt_size=total_conf*sizeof(ulong);   // Size required to hold message pointers
        msgalrt_ndx=(ulong*)malloc(msgalrt_size);// Allocate memory for all conferences pointers
        memset(msgalrt_ndx,'\0',msgalrt_size);   // Initialize ulong*

        if(msgalrt_ndx==NULL){
                cout << "\nError encountered allocating memory for MSGALRT.NDX";
                exit(1);
         }

         if((msgalrt_handle=open("MSGALRT.NDX",O_BINARY|O_RDWR|O_CREAT,S_IWRITE|S_IREAD))==-1){
                cout << "\nError encountered trying to open MSGALRT.NDX index file\n\a";
                exit(1);
          }
          ulong msgalrt_filesize=filelength(msgalrt_handle);         // GET SIZE OF FILE
          if (msgalrt_size<msgalrt_filesize) msgalrt_filesize=msgalrt_size;
                // In the above step we are making sure that the filesize is
                // not larger then the space we made provisions for.  This would
                // happen if conferences were deleted (from the end).

          // READ IN AVAILABLE CONFERENCES
          if((read(msgalrt_handle,msgalrt_ndx,msgalrt_filesize))!=msgalrt_filesize){
                cout << "\nError encountered trying to read in MSGALRT.NDX file";
                exit(1);
          }
          lseek(msgalrt_handle,0,SEEK_SET);       // Reset our file pointer because
                                                  // we will be writing new values.
          return total_conf;
}

// SAVE NEW MESSAGE POINTERS TO MSGALRT.NDX FILE
//
void save_msg_pointers(){
        // file postion was reset to 0 after opening/reading.
        //
        if((write(msgalrt_handle,msgalrt_ndx,msgalrt_size))!=msgalrt_size){
                cout << "\nError encountered writing MSGALRT.NDX index file";
                exit(1);
        }
}


// CLEAN-UP ON EXIT (WE HAVE A LOT OF FUNCTIONS THAT WILL EXIT IF NOT SUCCESSFUL)
//
void clean_house(){
        free(data);
        free(msgalrt_ndx);
        close(msgalrt_handle);
        cout << "\nPROCESS COMPLETE!!!";
}

main(int argc, char *argv[]){
        clrscr();
        if((strcmp(argv[1],"?"))==0) show_instructions();
        atexit(clean_house);

        if((strcmp(strupr(argv[1]),"/N"))==0) NWF=1;    // Check NetWorkFlag

        strcpy(cn,get_pcboard_dat(31));     // Line 31 is CALLER location.
        strcat(cn,".@@@");                  // We are setting up global variable.

        ulong total_conf=set_msg_pointers(); // Read in MSGALRT.NDX file

        cout << "Scanning MSGALRT.USR ";
        read_names();                        // Set the name record data

        for(ulong i=0;i<total_conf;i++){
                GET_CONF(i);                 // See if conferences is ACTIVE (sets 'conf_status')
                if(conf_status==1){  // only process if conference is ACTIVE
                        clrscr();
                        cout << "Processing conference #" <<i << "   ";
                        process_data(i);     // send conference number
                }
        }
        save_msg_pointers();                 // If we made it this far we were successful
        exit(0);
}
